From e1b4a1bbb7a9018d6a00a31d8558bb66617acb3f Mon Sep 17 00:00:00 2001
From: Mark Dilger <mark.dilger@enterprisedb.com>
Date: Thu, 19 Aug 2021 12:05:19 -0700
Subject: [PATCH v5 12/12] Create new role pg_manage_database_objects

Add a new role to the system with privileges to do anything to an
object that the object owner could do, so long as the object is not
owned by a superuser.  This latter restriction is to avoid privilege
escalation attacks.
---
 doc/src/sgml/user-manag.sgml            |   11 +
 src/backend/catalog/aclchk.c            |   47 +-
 src/backend/catalog/pg_type.c           |    4 +-
 src/backend/commands/alter.c            |   12 +-
 src/backend/commands/dbcommands.c       |    6 +-
 src/backend/commands/event_trigger.c    |    2 +-
 src/backend/commands/foreigncmds.c      |    4 +-
 src/backend/commands/publicationcmds.c  |    4 +-
 src/backend/commands/schemacmds.c       |    6 +-
 src/backend/commands/subscriptioncmds.c |    2 +-
 src/backend/commands/tablecmds.c        |    4 +-
 src/backend/commands/typecmds.c         |    4 +-
 src/backend/commands/user.c             |    6 +-
 src/backend/utils/adt/acl.c             |   56 +-
 src/include/catalog/pg_authid.dat       |    5 +
 src/include/utils/acl.h                 |    3 +
 src/test/regress/expected/role_priv.out | 1202 +++++++++++++++++++++++
 src/test/regress/parallel_schedule      |    2 +-
 src/test/regress/sql/role_priv.sql      |  879 +++++++++++++++++
 19 files changed, 2206 insertions(+), 53 deletions(-)
 create mode 100644 src/test/regress/expected/role_priv.out
 create mode 100644 src/test/regress/sql/role_priv.sql

diff --git a/doc/src/sgml/user-manag.sgml b/doc/src/sgml/user-manag.sgml
index 5fd8a5d2f7..596cf7ad7e 100644
--- a/doc/src/sgml/user-manag.sgml
+++ b/doc/src/sgml/user-manag.sgml
@@ -597,6 +597,10 @@ DROP ROLE doomed_role;
        <entry>pg_manage_logging_settings</entry>
        <entry>Allow changing settings which control logging behavior.</entry>
       </row>
+      <row>
+       <entry>pg_manage_database_objects</entry>
+       <entry>Allow altering database objects which the role does not own.</entry>
+      </row>
      </tbody>
     </tgroup>
    </table>
@@ -649,6 +653,13 @@ DROP ROLE doomed_role;
   server.
   </para>
 
+  <para>
+  The <literal>pg_manage_database_objects</literal> role is intended to allow
+  administrators to have trusted, but non-superuser, roles to perform actions
+  on objects with the same privileges as the object owners, so long as the
+  objects are not owned by superusers.
+  </para>
+
   <para>
   Care should be taken when granting these roles to ensure they are only used where
   needed and with the understanding that these roles grant access to privileged
diff --git a/src/backend/catalog/aclchk.c b/src/backend/catalog/aclchk.c
index 89792b154e..6c127333e9 100644
--- a/src/backend/catalog/aclchk.c
+++ b/src/backend/catalog/aclchk.c
@@ -3958,8 +3958,7 @@ pg_database_aclmask(Oid db_oid, Oid roleid,
 	Acl		   *acl;
 	Oid			ownerId;
 
-	/* Superusers bypass all permission checking. */
-	if (superuser_arg(roleid))
+	if (has_privs_of_role(roleid, ROLE_PG_MANAGE_DATABASE_OBJECTS))
 		return mask;
 
 	/*
@@ -4834,7 +4833,7 @@ pg_class_ownercheck(Oid class_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -4860,7 +4859,7 @@ pg_type_ownercheck(Oid type_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -4886,7 +4885,7 @@ pg_oper_ownercheck(Oid oper_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -4912,7 +4911,7 @@ pg_proc_ownercheck(Oid proc_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -4938,7 +4937,7 @@ pg_language_ownercheck(Oid lan_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -4984,7 +4983,7 @@ pg_largeobject_ownercheck(Oid lobj_oid, Oid roleid)
 	systable_endscan(scan);
 	table_close(pg_lo_meta, AccessShareLock);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5010,7 +5009,7 @@ pg_namespace_ownercheck(Oid nsp_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5037,7 +5036,7 @@ pg_tablespace_ownercheck(Oid spc_oid, Oid roleid)
 
 	ReleaseSysCache(spctuple);
 
-	return has_privs_of_role(roleid, spcowner);
+	return may_manage_roles_objects(roleid, spcowner);
 }
 
 /*
@@ -5064,7 +5063,7 @@ pg_opclass_ownercheck(Oid opc_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5091,7 +5090,7 @@ pg_opfamily_ownercheck(Oid opf_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5118,7 +5117,7 @@ pg_ts_dict_ownercheck(Oid dict_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5145,7 +5144,7 @@ pg_ts_config_ownercheck(Oid cfg_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5172,7 +5171,7 @@ pg_foreign_data_wrapper_ownercheck(Oid srv_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5199,7 +5198,7 @@ pg_foreign_server_ownercheck(Oid srv_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5226,7 +5225,7 @@ pg_event_trigger_ownercheck(Oid et_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5252,7 +5251,7 @@ pg_database_ownercheck(Oid db_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, dba);
+	return may_manage_roles_objects(roleid, dba);
 }
 
 /*
@@ -5278,7 +5277,7 @@ pg_collation_ownercheck(Oid coll_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5304,7 +5303,7 @@ pg_conversion_ownercheck(Oid conv_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5346,7 +5345,7 @@ pg_extension_ownercheck(Oid ext_oid, Oid roleid)
 	systable_endscan(scan);
 	table_close(pg_extension, AccessShareLock);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5372,7 +5371,7 @@ pg_publication_ownercheck(Oid pub_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5398,7 +5397,7 @@ pg_subscription_ownercheck(Oid sub_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
@@ -5425,7 +5424,7 @@ pg_statistics_object_ownercheck(Oid stat_oid, Oid roleid)
 
 	ReleaseSysCache(tuple);
 
-	return has_privs_of_role(roleid, ownerId);
+	return may_manage_roles_objects(roleid, ownerId);
 }
 
 /*
diff --git a/src/backend/catalog/pg_type.c b/src/backend/catalog/pg_type.c
index cdce22f394..f6cf776849 100644
--- a/src/backend/catalog/pg_type.c
+++ b/src/backend/catalog/pg_type.c
@@ -22,6 +22,7 @@
 #include "catalog/dependency.h"
 #include "catalog/indexing.h"
 #include "catalog/objectaccess.h"
+#include "catalog/pg_authid.h"
 #include "catalog/pg_collation.h"
 #include "catalog/pg_namespace.h"
 #include "catalog/pg_proc.h"
@@ -438,7 +439,8 @@ TypeCreate(Oid newTypeOid,
 		/*
 		 * shell type must have been created by same owner
 		 */
-		if (typform->typowner != ownerId)
+		if (typform->typowner != ownerId &&
+			!has_privs_of_role(ownerId, ROLE_PG_MANAGE_DATABASE_OBJECTS))
 			aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_TYPE, typeName);
 
 		/* trouble if caller wanted to force the OID */
diff --git a/src/backend/commands/alter.c b/src/backend/commands/alter.c
index 29249498a9..0b33cc9c97 100644
--- a/src/backend/commands/alter.c
+++ b/src/backend/commands/alter.c
@@ -221,7 +221,7 @@ AlterObjectRename_internal(Relation rel, Oid objectId, const char *new_name)
 		Assert(!isnull);
 		ownerId = DatumGetObjectId(datum);
 
-		if (!has_privs_of_role(GetUserId(), DatumGetObjectId(ownerId)))
+		if (!may_manage_roles_objects(GetUserId(), DatumGetObjectId(ownerId)))
 			aclcheck_error(ACLCHECK_NOT_OWNER, get_object_type(classId, objectId),
 						   old_name);
 
@@ -749,7 +749,7 @@ AlterObjectNamespace_internal(Relation rel, Oid objid, Oid nspOid)
 		Assert(!isnull);
 		ownerId = DatumGetObjectId(owner);
 
-		if (!has_privs_of_role(GetUserId(), ownerId))
+		if (!may_manage_roles_objects(GetUserId(), ownerId))
 			aclcheck_error(ACLCHECK_NOT_OWNER, get_object_type(classId, objid),
 						   NameStr(*(DatumGetName(name))));
 
@@ -974,8 +974,8 @@ AlterObjectOwner_internal(Relation rel, Oid objectId, Oid new_ownerId)
 		/* Superusers can bypass permission checks */
 		if (!superuser())
 		{
-			/* must be owner */
-			if (!has_privs_of_role(GetUserId(), old_ownerId))
+			/* must be able to act as owner */
+			if (!may_manage_roles_objects(GetUserId(), old_ownerId))
 			{
 				char	   *objname;
 				char		namebuf[NAMEDATALEN];
@@ -995,8 +995,8 @@ AlterObjectOwner_internal(Relation rel, Oid objectId, Oid new_ownerId)
 				aclcheck_error(ACLCHECK_NOT_OWNER, get_object_type(classId, objectId),
 							   objname);
 			}
-			/* Must be able to become new owner */
-			check_is_member_of_role(GetUserId(), new_ownerId);
+			/* Must be able to act as new owner */
+			check_may_manage_roles_objects(GetUserId(), new_ownerId);
 
 			/* New owner must have CREATE privilege on namespace */
 			if (OidIsValid(namespaceId))
diff --git a/src/backend/commands/dbcommands.c b/src/backend/commands/dbcommands.c
index 029fab48df..35d5419689 100644
--- a/src/backend/commands/dbcommands.c
+++ b/src/backend/commands/dbcommands.c
@@ -302,7 +302,7 @@ createdb(ParseState *pstate, const CreatedbStmt *stmt)
 				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 				 errmsg("permission denied to create database")));
 
-	check_is_member_of_role(GetUserId(), datdba);
+	check_may_manage_roles_objects(GetUserId(), datdba);
 
 	/*
 	 * Lookup database (template) to be cloned, and obtain share lock on it.
@@ -1682,8 +1682,8 @@ AlterDatabaseOwner(const char *dbname, Oid newOwnerId)
 			aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_DATABASE,
 						   dbname);
 
-		/* Must be able to become new owner */
-		check_is_member_of_role(GetUserId(), newOwnerId);
+		/* Must be able to act as new owner */
+		check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 		/*
 		 * must have createdb rights
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index 13db569775..e10261ec49 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -477,7 +477,7 @@ AlterEventTriggerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 					   NameStr(form->evtname));
 
 	/* Must be able to assign ownership to the target role */
-	check_is_member_of_role(GetUserId(), newOwnerId);
+	check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 	form->evtowner = newOwnerId;
 	CatalogTupleUpdate(rel, &tup->t_self, tup);
diff --git a/src/backend/commands/foreigncmds.c b/src/backend/commands/foreigncmds.c
index 9b71beb1d3..ed995b175c 100644
--- a/src/backend/commands/foreigncmds.c
+++ b/src/backend/commands/foreigncmds.c
@@ -362,8 +362,8 @@ AlterForeignServerOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 				aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_FOREIGN_SERVER,
 							   NameStr(form->srvname));
 
-			/* Must be able to become new owner */
-			check_is_member_of_role(GetUserId(), newOwnerId);
+			/* Must be able to act as new owner */
+			check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 			/* New owner must have USAGE privilege on foreign-data wrapper */
 			aclresult = pg_foreign_data_wrapper_aclcheck(form->srvfdw, newOwnerId, ACL_USAGE);
diff --git a/src/backend/commands/publicationcmds.c b/src/backend/commands/publicationcmds.c
index 8487eeb7e6..105414332c 100644
--- a/src/backend/commands/publicationcmds.c
+++ b/src/backend/commands/publicationcmds.c
@@ -687,8 +687,8 @@ AlterPublicationOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 			aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_PUBLICATION,
 						   NameStr(form->pubname));
 
-		/* Must be able to become new owner */
-		check_is_member_of_role(GetUserId(), newOwnerId);
+		/* Must be able to act as new owner */
+		check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 		/* New owner must have CREATE privilege on database */
 		aclresult = pg_database_aclcheck(MyDatabaseId, newOwnerId, ACL_CREATE);
diff --git a/src/backend/commands/schemacmds.c b/src/backend/commands/schemacmds.c
index 6c6ab9ee34..901deccba9 100644
--- a/src/backend/commands/schemacmds.c
+++ b/src/backend/commands/schemacmds.c
@@ -96,7 +96,7 @@ CreateSchemaCommand(CreateSchemaStmt *stmt, const char *queryString,
 		aclcheck_error(aclresult, OBJECT_DATABASE,
 					   get_database_name(MyDatabaseId));
 
-	check_is_member_of_role(saved_uid, owner_uid);
+	check_may_manage_roles_objects(saved_uid, owner_uid);
 
 	/* Additional check to protect reserved schema names */
 	if (!allowSystemTableMods && IsReservedName(schemaName))
@@ -357,8 +357,8 @@ AlterSchemaOwner_internal(HeapTuple tup, Relation rel, Oid newOwnerId)
 			aclcheck_error(ACLCHECK_NOT_OWNER, OBJECT_SCHEMA,
 						   NameStr(nspForm->nspname));
 
-		/* Must be able to become new owner */
-		check_is_member_of_role(GetUserId(), newOwnerId);
+		/* Must be able to act as new owner */
+		check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 		/*
 		 * must have create-schema rights
diff --git a/src/backend/commands/subscriptioncmds.c b/src/backend/commands/subscriptioncmds.c
index eacb1a4a00..57666f30ba 100644
--- a/src/backend/commands/subscriptioncmds.c
+++ b/src/backend/commands/subscriptioncmds.c
@@ -1480,7 +1480,7 @@ AlterSubscriptionOwner_internal(Relation rel, HeapTuple tup, Oid newOwnerId)
 					   NameStr(form->subname));
 
 	/* Must be able to assign ownership to the target role */
-	check_is_member_of_role(GetUserId(), newOwnerId);
+	check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 	form->subowner = newOwnerId;
 	CatalogTupleUpdate(rel, &tup->t_self, tup);
diff --git a/src/backend/commands/tablecmds.c b/src/backend/commands/tablecmds.c
index a03077139d..34acf59039 100644
--- a/src/backend/commands/tablecmds.c
+++ b/src/backend/commands/tablecmds.c
@@ -13322,8 +13322,8 @@ ATExecChangeOwner(Oid relationOid, Oid newOwnerId, bool recursing, LOCKMODE lock
 					aclcheck_error(ACLCHECK_NOT_OWNER, get_relkind_objtype(get_rel_relkind(relationOid)),
 								   RelationGetRelationName(target_rel));
 
-				/* Must be able to become new owner */
-				check_is_member_of_role(GetUserId(), newOwnerId);
+				/* Must be able to act as new owner */
+				check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 				/* New owner must have CREATE privilege on namespace */
 				aclresult = pg_namespace_aclcheck(namespaceOid, newOwnerId,
diff --git a/src/backend/commands/typecmds.c b/src/backend/commands/typecmds.c
index 6bdb1a1660..a8cb8ecb58 100644
--- a/src/backend/commands/typecmds.c
+++ b/src/backend/commands/typecmds.c
@@ -3748,8 +3748,8 @@ AlterTypeOwner(List *names, Oid newOwnerId, ObjectType objecttype)
 			if (!pg_type_ownercheck(typTup->oid, GetUserId()))
 				aclcheck_error_type(ACLCHECK_NOT_OWNER, typTup->oid);
 
-			/* Must be able to become new owner */
-			check_is_member_of_role(GetUserId(), newOwnerId);
+			/* Must be able to act as new owner */
+			check_may_manage_roles_objects(GetUserId(), newOwnerId);
 
 			/* New owner must have CREATE privilege on namespace */
 			aclresult = pg_namespace_aclcheck(typTup->typnamespace,
diff --git a/src/backend/commands/user.c b/src/backend/commands/user.c
index aa69821be4..3cd874b170 100644
--- a/src/backend/commands/user.c
+++ b/src/backend/commands/user.c
@@ -1320,7 +1320,7 @@ DropOwnedObjects(DropOwnedStmt *stmt)
 	{
 		Oid			roleid = lfirst_oid(cell);
 
-		if (!has_privs_of_role(GetUserId(), roleid))
+		if (!may_manage_roles_objects(GetUserId(), roleid))
 			ereport(ERROR,
 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 					 errmsg("permission denied to drop objects")));
@@ -1347,7 +1347,7 @@ ReassignOwnedObjects(ReassignOwnedStmt *stmt)
 	{
 		Oid			roleid = lfirst_oid(cell);
 
-		if (!has_privs_of_role(GetUserId(), roleid))
+		if (!may_manage_roles_objects(GetUserId(), roleid))
 			ereport(ERROR,
 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 					 errmsg("permission denied to reassign objects")));
@@ -1356,7 +1356,7 @@ ReassignOwnedObjects(ReassignOwnedStmt *stmt)
 	/* Must have privileges on the receiving side too */
 	newrole = get_rolespec_oid(stmt->newrole, false);
 
-	if (!has_privs_of_role(GetUserId(), newrole))
+	if (!may_manage_roles_objects(GetUserId(), newrole))
 		ereport(ERROR,
 				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 				 errmsg("permission denied to reassign objects")));
diff --git a/src/backend/utils/adt/acl.c b/src/backend/utils/adt/acl.c
index 67f8b29434..1a467d0370 100644
--- a/src/backend/utils/adt/acl.c
+++ b/src/backend/utils/adt/acl.c
@@ -1329,7 +1329,7 @@ aclmask(const Acl *acl, Oid roleid, Oid ownerId,
 
 	/* Owner always implicitly has all grant options */
 	if ((mask & ACLITEM_ALL_GOPTION_BITS) &&
-		has_privs_of_role(roleid, ownerId))
+		may_manage_roles_objects(roleid, ownerId))
 	{
 		result = mask & ACLITEM_ALL_GOPTION_BITS;
 		if ((how == ACLMASK_ALL) ? (result == mask) : (result != 0))
@@ -1372,7 +1372,7 @@ aclmask(const Acl *acl, Oid roleid, Oid ownerId,
 			continue;			/* already checked it */
 
 		if ((aidata->ai_privs & remaining) &&
-			has_privs_of_role(roleid, aidata->ai_grantee))
+			may_manage_roles_objects(roleid, aidata->ai_grantee))
 		{
 			result |= aidata->ai_privs & mask;
 			if ((how == ACLMASK_ALL) ? (result == mask) : (result != 0))
@@ -4859,6 +4859,43 @@ has_privs_of_role(Oid member, Oid role)
 						   role);
 }
 
+/*
+ * Does member have the privileges of role, or failing that, does member
+ * have the right to manage role's objects.
+ *
+ * Members of role pg_manage_database_objects may manage role's objects
+ * if and only if role is not a superuser.
+ */
+bool
+may_manage_roles_objects(Oid member, Oid role)
+{
+	List    *roles;
+
+	/* Fast path for simple case */
+	if (member == role)
+		return true;
+
+	/* Superusers have every privilege, so are part of every role */
+	if (superuser_arg(member))
+		return true;
+
+	/*
+	 * Find all the roles that member has the privileges of, including
+	 * multi-level recursion.
+	 */
+	roles = roles_is_member_of(member, ROLERECURSE_PRIVS, InvalidOid, NULL);
+
+	/* role may manage its own objects. */
+	if (list_member_oid(roles, role))
+		return true;
+
+	/* pg_manage_database_objects may manage non-superuser owned objects. */
+	if (!superuser_arg(role) &&
+		list_member_oid(roles, ROLE_PG_MANAGE_DATABASE_OBJECTS))
+		return true;
+
+	return false;
+}
 
 /*
  * Is member a member of role (directly or indirectly)?
@@ -4899,6 +4936,21 @@ check_is_member_of_role(Oid member, Oid role)
 						GetUserNameFromId(role, false))));
 }
 
+/*
+ * check_may_manage_roles_objects
+ *		may_manage_roles_objects with a standard permission-violation error if
+ *		not
+ */
+void
+check_may_manage_roles_objects(Oid member, Oid role)
+{
+	if (!may_manage_roles_objects(member, role))
+		ereport(ERROR,
+				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+				 errmsg("must be member of role \"%s\"",
+						GetUserNameFromId(role, false))));
+}
+
 /*
  * Is member a member of role, not considering superuserness?
  *
diff --git a/src/include/utils/acl.h b/src/include/utils/acl.h
index af771c901d..ddcbada55d 100644
--- a/src/include/utils/acl.h
+++ b/src/include/utils/acl.h
@@ -206,10 +206,13 @@ extern AclMode aclmask(const Acl *acl, Oid roleid, Oid ownerId,
 extern int	aclmembers(const Acl *acl, Oid **roleids);
 
 extern bool has_privs_of_role(Oid member, Oid role);
+extern bool may_manage_roles_objects(Oid member, Oid role);
 extern bool is_member_of_role(Oid member, Oid role);
+extern bool may_manage_roles_objects(Oid member, Oid role);
 extern bool is_member_of_role_nosuper(Oid member, Oid role);
 extern bool is_admin_of_role(Oid member, Oid role);
 extern void check_is_member_of_role(Oid member, Oid role);
+extern void check_may_manage_roles_objects(Oid member, Oid role);
 extern Oid	get_role_oid(const char *rolename, bool missing_ok);
 extern Oid	get_role_oid_or_public(const char *rolename);
 extern Oid	get_rolespec_oid(const RoleSpec *role, bool missing_ok);
diff --git a/src/test/regress/parallel_schedule b/src/test/regress/parallel_schedule
index 8fd9d215ff..b47b7dee8c 100644
--- a/src/test/regress/parallel_schedule
+++ b/src/test/regress/parallel_schedule
@@ -103,7 +103,7 @@ test: publication subscription
 # ----------
 # Another group of parallel tests
 # ----------
-test: select_views portals_p2 foreign_key cluster dependency guc bitmapops combocid tsearch tsdicts foreign_data window xmlmap functional_deps advisory_lock indirect_toast equivclass
+test: select_views portals_p2 foreign_key cluster dependency guc bitmapops combocid tsearch tsdicts foreign_data window xmlmap functional_deps advisory_lock indirect_toast equivclass role_priv
 
 # ----------
 # Another group of parallel tests (JSON related)
